//Source file: PolicyActionListElement.java
//Date: September 2004
//Policy Management Data Types for 3GPP TS 29.198-13 V5.6.0

package org.csapi.jr.se.policy;

/**
 * This data type is a Sequence of Data Elements which describes one element of a action list. It is a structured data type consisting of a {action, sequenceNumber ) pair.
 * 
 */
public final class PolicyActionListElement implements java.io.Serializable {

    private org.csapi.jr.se.policy.PolicyAction action;
    private int sequenceNumber;

    /**
     * Creates a new PolicyActionListElement instance.
     */
    public PolicyActionListElement () {}

    /**
     * Creates a new PolicyActionListElement instance.
     * @param _action   
     * @param _sequenceNumber   
     */
    public PolicyActionListElement (org.csapi.jr.se.policy.PolicyAction _action, int _sequenceNumber) {

        this.action = _action;
        this.sequenceNumber = _sequenceNumber;
    }

    /**
     * This method returns a action.
     * 
     * @return a org.csapi.jr.se.policy.PolicyAction value
     */
    public org.csapi.jr.se.policy.PolicyAction getAction() {
        return action;
    }

    /**
     * This method returns a sequenceNumber.
     * 
     * @return a int value
     */
    public int getSequenceNumber() {
        return sequenceNumber;
    }


    /**
     * This method sets a action.
     */ 
    public void setAction(org.csapi.jr.se.policy.PolicyAction action) {
        this.action = action;
    }

    /**
     * This method sets a sequenceNumber.
     */ 
    public void setSequenceNumber(int sequenceNumber) {
        this.sequenceNumber = sequenceNumber;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PolicyActionListElement)) {
            return false;
        } 
        PolicyActionListElement policyActionListElement = (PolicyActionListElement) o;
        if ((this.action != null) && (policyActionListElement.action != null)) {
            if(!(this.action.equals(policyActionListElement.action))) {
                return false;
            }
        }
        if(!(this.sequenceNumber == policyActionListElement.sequenceNumber)) {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PolicyActionListElement

