//Source file: PolicyGroup.java
//Date: September 2004
//Policy Management Interfaces for 3GPP TS 29.198-13 V5.6.0

package org.csapi.jr.se.policy;

/**
 * This interface represents a PolicyGroup.<BR>
 *
 */
public interface PolicyGroup extends org.csapi.jr.se.Service {

    /**
     * Invokes the getParentDomain() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyDomain getParentDomain()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the getParentGroup() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyGroup getParentGroup()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the createGroup() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyGroup createGroup(
           java.lang.String                groupName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getGroup() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyGroup getGroup(
           java.lang.String                groupName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeGroup() method on the Parlay Gateway.
     */
    void removeGroup(
           java.lang.String                groupName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getGroupCount() method on the Parlay Gateway.
     */
    int getGroupCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getGroupIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyIterator getGroupIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createRule() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyRule createRule(
           java.lang.String                ruleName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getRule() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyRule getRule(
           java.lang.String                ruleName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeRule() method on the Parlay Gateway.
     */
    void removeRule(
           java.lang.String                ruleName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getRuleCount() method on the Parlay Gateway.
     */
    int getRuleCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getRuleIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyIterator getRuleIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

}
