//Source file: PolicyManager.java
//Date: September 2004
//Policy Management Interfaces for 3GPP TS 29.198-13 V5.6.0

package org.csapi.jr.se.policy;

/**
 * This interface represents a PolicyManager.<BR>
 *
 */
public interface PolicyManager extends org.csapi.jr.se.Service {

    /**
     * Invokes the createDomain() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyDomain createDomain(
           java.lang.String                domainName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getDomain() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyDomain getDomain(
           java.lang.String                domainName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeDomain() method on the Parlay Gateway.
     */
    void removeDomain(
           java.lang.String                domainName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getDomainCount() method on the Parlay Gateway.
     */
    int getDomainCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getDomainIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyIterator getDomainIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the findMatchingDomains() method on the Parlay Gateway.
     */
    java.lang.String[] findMatchingDomains(
           org.csapi.jr.se.Attribute[] matchingAttributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createRepository() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyRepository createRepository(
           java.lang.String                repositoryName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getRepository() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyRepository getRepository(
           java.lang.String                repositoryName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeRepository() method on the Parlay Gateway.
     */
    void removeRepository(
           java.lang.String                repositoryName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getRepositoryCount() method on the Parlay Gateway.
     */
    int getRepositoryCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getRepositoryIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyIterator getRepositoryIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the startTransaction() method on the Parlay Gateway.
     */
    void startTransaction()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.TransactionInProcessException;

    /**
     * Invokes the commitTransaction() method on the Parlay Gateway.
     */
    boolean commitTransaction()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the abortTransaction() method on the Parlay Gateway.
     */
    void abortTransaction()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

}
