//Source file: PolicyRepository.java
//Date: September 2004
//Policy Management Interfaces for 3GPP TS 29.198-13 V5.6.0

package org.csapi.jr.se.policy;

/**
 * This interface represents a PolicyRepository.<BR>
 *
 */
public interface PolicyRepository extends org.csapi.jr.se.Service {

    /**
     * Invokes the getParentRepository() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyRepository getParentRepository()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the createRepository() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyRepository createRepository(
           java.lang.String                repositoryName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getRepository() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyRepository getRepository(
           java.lang.String                repositoryName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeRepository() method on the Parlay Gateway.
     */
    void removeRepository(
           java.lang.String                repositoryName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getRepositoryCount() method on the Parlay Gateway.
     */
    int getRepositoryCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getRepositoryIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyIterator getRepositoryIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createCondition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyCondition createCondition(
           java.lang.String                conditionName,
           org.csapi.jr.se.policy.PolicyConditionType conditionType,
           org.csapi.jr.se.Attribute[] conditionAttributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getCondition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyCondition getCondition(
           java.lang.String                conditionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeCondition() method on the Parlay Gateway.
     */
    void removeCondition(
           java.lang.String                conditionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getConditionCount() method on the Parlay Gateway.
     */
    int getConditionCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getConditionIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyIterator getConditionIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the createAction() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyAction createAction(
           java.lang.String                actionName,
           org.csapi.jr.se.policy.PolicyActionType actionType,
           org.csapi.jr.se.Attribute[] actionAttributes)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getAction() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyAction getAction(
           java.lang.String                actionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException;

    /**
     * Invokes the removeAction() method on the Parlay Gateway.
     */
    void removeAction(
           java.lang.String                actionName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException,
       org.csapi.jr.se.policy.SyntaxErrorException,
       org.csapi.jr.se.policy.NameSpaceErrorException,
       org.csapi.jr.se.policy.NoTransactionInProcessException;

    /**
     * Invokes the getActionCount() method on the Parlay Gateway.
     */
    int getActionCount()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

    /**
     * Invokes the getActionIterator() method on the Parlay Gateway.
     */
    org.csapi.jr.se.policy.PolicyIterator getActionIterator()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.policy.AccessViolationException;

}
