//Source file: ReportNotificationEvent.java
//Date: September 2004
//Policy Management Interfaces for 3GPP TS 29.198-13 V5.6.0

package org.csapi.jr.se.policy;

/**
 * Event created by an activity object to indicate that a Gateway originated 
 * call to the reportNotification() method on the callback interface 
 * has occured.<BR>
 *
 */
public final class ReportNotificationEvent extends java.util.EventObject {

    /**
     * Constructor for the ReportNotificationEvent Event.
     *
     * @param  source      Reference to the object firing the event.<BR>
     */
    public ReportNotificationEvent(java.lang.Object source,
        org.csapi.jr.se.policy.PolicyEvent event) {

        super(source);
      this.event = event;
 
    }

    org.csapi.jr.se.policy.PolicyEvent event;

    /**
     *  This method is used to retrieve the parameter value of 'event' passed up
     *  from the Gateway in it's call to the reportNotification() method, used on
     *  the creation of this event.
     *
     * @return    The value of 'event' used on creation of this event.
     */
    public org.csapi.jr.se.policy.PolicyEvent getEvent() {

        return this.event;
    }
       
}

