//Source file: TransactionInProcessException.java
//Date: September 2004
//Policy Management Data Types for 3GPP TS 29.198-13 V5.6.0

package org.csapi.jr.se.policy;

/**
 * Thrown if there is currently a transaction in process. Note that transactions can not be nested, that is, a second call to startTransaction() without calling commitTransaction() or abortTransaction() in between will result in this exception being thrown during the second call.
 *
 */
public class TransactionInProcessException extends org.csapi.jr.se.policy.PolicyException {

    private Throwable _cause = null;

    public TransactionInProcessException() {
        super(); 
    }

    public TransactionInProcessException(String message) {
        super(message); 
    }

    public TransactionInProcessException(String message, Throwable cause) {
        super(message); 
        _cause = cause;
    }

    public TransactionInProcessException(Throwable cause) {
        _cause = cause; 
    }

    public Throwable getCause() {
        return _cause;
    } 

} // TransactionInProcessException

